﻿using System.IdentityModel.Selectors;
using System.IdentityModel.Tokens;
using System.ServiceModel;
using System.ServiceModel.Description;
using System.ServiceModel.Security;
using System.Xml;

//Neccessary fur .NET Framework < 4
//Security Header has to be generated manually
namespace MyNameSpace {
   public class CustomCredentials : ClientCredentials
    {
        public CustomCredentials()
        { }

        protected CustomCredentials(CustomCredentials cc)
            : base(cc)
        {
        }

        public override SecurityTokenManager CreateSecurityTokenManager()
        {
            return new CustomSecurityTokenManager(this);
        }

        protected override ClientCredentials CloneCore()
        {
            return new CustomCredentials(this);
        }
    }

    internal class CustomSecurityTokenManager : ClientCredentialsSecurityTokenManager
    {
        public CustomSecurityTokenManager(CustomCredentials cred)
            : base(cred)
        {
        }

        public override SecurityTokenSerializer CreateSecurityTokenSerializer(SecurityTokenVersion version)
        {
            return new CustomTokenSerializer(SecurityVersion.WSSecurity11);
        }
    }

    internal class CustomTokenSerializer : WSSecurityTokenSerializer
    {
        public CustomTokenSerializer(SecurityVersion sv)
            : base(sv)
        {
        }

        protected override void WriteTokenCore(XmlWriter writer, SecurityToken token)
        {
            UserNameSecurityToken unToken = (UserNameSecurityToken) token;
            writer.WriteRaw(@"<o:UsernameToken u:Id=""" + token.Id + @"""> <o:Username>" + unToken.UserName + @"</o:Username> <o:Password Type=""http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-username-token-profile-1.0#PasswordText"">" + unToken.Password + @"</o:Password></o:UsernameToken>");
        }
    }
}
